Add Two Numbers - Leetcode 2 - Python

Ғылым және технология

🚀 neetcode.io/ - A better way to prepare for Coding Interviews
🐦 Twitter: / neetcode1
🥷 Discord: / discord
🐮 Support the channel: / neetcode
💡 CODING SOLUTIONS: • Coding Interview Solut...
💡 DYNAMIC PROGRAMMING PLAYLIST: • House Robber - Leetco...
🌲 TREE PLAYLIST: • Invert Binary Tree - D...
💡 GRAPH PLAYLIST: • Course Schedule - Grap...
💡 BACKTRACKING PLAYLIST: • Word Search - Backtrac...
💡 LINKED LIST PLAYLIST: • Reverse Linked List - ...
Problem link: neetcode.io/problems/add-two-...
0:00 - Visual Explanation
5:30 - Coding Solution
Leetcode 2
#amazon #interview #leetcode
Disclosure: Some of the links above may be affiliate links, from which I may earn a small commission.

Пікірлер: 226

  • @NeetCode
    @NeetCode3 жыл бұрын

    🚀 neetcode.io/ - A better way to prepare for Coding Interviews

  • @oanamanaljav

    @oanamanaljav

    3 жыл бұрын

    Seems like the code is not working. Showed me the wrong result when compile.

  • @e-raticartist
    @e-raticartist Жыл бұрын

    hearing "hey guys i'm still unemployed so let's solve a leetcode problem today" and knowing you became a software engineer at google is so real and inspiring bro, thanks

  • @alwin5995

    @alwin5995

    7 ай бұрын

    Bruh he left job at amazon, and decided to voluntarily be unemployed. Dude's been a genius all along.

  • @rohitkumarsinha876
    @rohitkumarsinha8763 жыл бұрын

    "hey guys i am still unemployed so lets solve a problem " this is savage bro

  • @farnazzinnah8541

    @farnazzinnah8541

    2 жыл бұрын

    he earns fro youtube tho

  • @samirpaul2

    @samirpaul2

    2 жыл бұрын

    😂

  • @computergeek5657

    @computergeek5657

    2 жыл бұрын

    KZread hired him

  • @neerajmahapatra5239

    @neerajmahapatra5239

    2 жыл бұрын

    Now he is at google

  • @omkarjadhav8482

    @omkarjadhav8482

    2 жыл бұрын

    💯😂

  • @chair_smesh
    @chair_smesh2 жыл бұрын

    I get so inspired/motivated when you mention unemployment in your old videos because of where you ended up

  • @smalldoggo3704
    @smalldoggo37043 жыл бұрын

    that intro hit me different

  • @NeetCode

    @NeetCode

    3 жыл бұрын

    lol

  • @mehmetnadi8930
    @mehmetnadi89302 жыл бұрын

    I've been watching your solutions for a while now and I'm just so happy that I finally started to solve problems like the way you do. Thank you so much!!

  • @snoudoubts1745
    @snoudoubts17452 жыл бұрын

    That beginning took me by surprise, instantly made my evening better. Thanks

  • @syafzal273
    @syafzal2736 ай бұрын

    Awesome, I love how you dealt with all the edge cases without cluttering the code

  • @bigrat5101
    @bigrat51012 жыл бұрын

    "hey guys i am still unemployed so lets solve a problem " this one cracked me up because right now all your efforts paid off and look back, we all have been there..ah what a journey!!!

  • @anantmulchandani709
    @anantmulchandani7092 жыл бұрын

    Congratulations that you are now employed!! Happy for you!

  • @passionatechristianworker
    @passionatechristianworker3 ай бұрын

    i'm amazed at your ability. it's the nuances in the code that's the hardest to figure out. kudos to you.

  • @raymondcordero9718
    @raymondcordero9718 Жыл бұрын

    By far the best explanation of this problem I’ve seen 👏 Thanks for sharing

  • @anamikaborah5393
    @anamikaborah53935 ай бұрын

    Love how you started the video! xD You made my life easier by posting these videos. Great work! :) :D

  • @philhamlin7935
    @philhamlin79352 жыл бұрын

    Excellent! Clear and plain explanations, and it's so much cleaner when hand mark-up is by pen instead of by mouse. :) This is linked in LeetCode as "optimized solution explained" on the problem itself, but it'd be faster to take: carry = val // 10 val = val % 10 ...and make it instead: carry = 1 val = val - 10 The modulus approach is fantastic for expanding our algorithm to support adding up three or more arrays, but in our use case carry will always be 0 or 1.

  • @stementhusiast816

    @stementhusiast816

    2 жыл бұрын

    You would require 'if' statements. if val >= 10: carry = 1 val = val - 10 Which would reduce the elegance of code

  • @khatharrmalkavian3306

    @khatharrmalkavian3306

    2 жыл бұрын

    Nothing about this problem is elegant or worth optimization.

  • @anthonypeters1797
    @anthonypeters17972 жыл бұрын

    Couldn’t have solved this without you. Thank you so much

  • @alok7485

    @alok7485

    2 жыл бұрын

    Can you please explain what will be the time complexity and space complexity for this piece of code in example?

  • @user-hg9zo5gu7v
    @user-hg9zo5gu7v8 ай бұрын

    Explanation was crystal clear and helped me solve the problem super quick. Thanks!

  • @techbrojoe
    @techbrojoe2 жыл бұрын

    Thanks for making this. Trying this problem is the first time I've ever tried using a Linked List, so this helped solidify the solution LeetCode provides.

  • @alok7485

    @alok7485

    2 жыл бұрын

    Can you please explain what will be the time complexity and space complexity for this piece of code in example?

  • @miyamotomusashi4556
    @miyamotomusashi45562 жыл бұрын

    Wow, this was very well explained!

  • @MrYosuko
    @MrYosuko5 ай бұрын

    The intro slapped me back into reality. As always, thanks for the awesome explanations 😄

  • @pahul79
    @pahul79 Жыл бұрын

    thanks for making these videos man, your awesome

  • @siruitao
    @siruitao Жыл бұрын

    Haha, now you are so employed! Thanks for these great contents!

  • @Eftahhh
    @Eftahhh3 жыл бұрын

    So simple, thank you. I was casting the linked list values to strings and reversing them, then casting them back to ints and adding them... needless to say I was making spaghetti. Your example is very clean!

  • @prudvi01

    @prudvi01

    3 жыл бұрын

    lol that was my initial solution as well! got dirty real quick

  • @liferayasif9382

    @liferayasif9382

    3 жыл бұрын

    I did same, thanks

  • @UnknownSend3r

    @UnknownSend3r

    2 жыл бұрын

    @@prudvi01 I used an if statement inside a while loop, would that be wrong even if it works, if not what's wrong with it ? As in does the solution have to be a linked list.

  • @BromaniJones

    @BromaniJones

    2 жыл бұрын

    I did the same. I'm not convinved it's any worse than the solution presented in the video. looping through two linked lists (and a third for the output) is O(n) time complexity.

  • @gustavotelez9795

    @gustavotelez9795

    Жыл бұрын

    def addTwoNumbers(l1,l2): l1.reverse() l2.reverse() l1s= str(l1) l2s= str(l2) l1s= "".join(l1s) l2s= "".join(l2s) l1 = "" l2 = "" for i in range(1, len(l1s), 3): l1 +=l1s[i] for i in range(1, len(l2s), 3): l2 +=l2s[i] l1s=int(l1) l2s=int(l2) res=l1s+l2s res= str(res) res= list(res) res.reverse() return res

  • @whatdoiputhere5089
    @whatdoiputhere50892 жыл бұрын

    Dude, thankyou for this solutions. They are helping me alottttt! Also, if you could please make a video on intersection of two linked lists

  • @alok7485

    @alok7485

    2 жыл бұрын

    Can you please explain what will be the time complexity and space complexity for this piece of code in example?

  • @MrBear-no7iq
    @MrBear-no7iq3 жыл бұрын

    Thank you !! I finally understand it now

  • @ozgeylmaz8685
    @ozgeylmaz8685 Жыл бұрын

    Great video and great channel I am very excited to discover this channel I hope I benefit from this channel a lot .Thanks a lot😊

  • @ishaanbhalla396
    @ishaanbhalla3962 жыл бұрын

    Man I was super stressed out solving these leetcodes, but the " Hey I am still unemployed" made my day! LMAO

  • @pratikshanaik4143
    @pratikshanaik4143 Жыл бұрын

    Better explanation than the official solution explanation.

  • @__________________________6910
    @__________________________69102 жыл бұрын

    You are best. I always pause ads blocker for you.

  • @SweVillian-mt6nk
    @SweVillian-mt6nk4 ай бұрын

    This intro make this video my favorite one 😂. Could be a useful cue to remember the solution in an interview even.

  • @morenoh149
    @morenoh149 Жыл бұрын

    its interesting how you build the answer after the dummy node and return the answer. Its not like the test cases can detect the dummy node

  • @heyyy_rosa4520
    @heyyy_rosa45202 жыл бұрын

    This solution is so elegant.

  • @passionatechristianworker
    @passionatechristianworker3 ай бұрын

    "you probably do but you might think you don't". Haha, thanks for the encouragement.

  • @bilal2.042
    @bilal2.0422 жыл бұрын

    thank you for the explaination :)

  • @mu0325
    @mu03253 жыл бұрын

    I traversed through both linked list and got the actual numbers, added them, then created a linked list with the result's digits as nodes.

  • @inspisiavideos8542

    @inspisiavideos8542

    2 жыл бұрын

    hi, Please let me know. Why is the value divided by 10? I'm learning how to code and I don't know where he got the number 10? (on minute 7:29)

  • @danielwilczak7833

    @danielwilczak7833

    2 жыл бұрын

    ​@@inspisiavideos8542 You divide by 10 so that you can add it to the next number which will be in the next 10's place. For example: if you took 25 + 26 if you add 5 + 6 and then divide by 10 you'll get 1. So i take my one and add it to the next 10's place which is 2 + 2 + 1 that i got from carrying the number which will total 51.

  • @inspisiavideos8542

    @inspisiavideos8542

    2 жыл бұрын

    @@danielwilczak7833 Thank you so much!!! I got an internship during this Summer as QA and just finished it but I asked for an extension and if I could get it this time as Dev. They said yes. I have coded before with courses on how to make websites but I have never done code questions. Basically this next week is my first week. It’s so hard to get a job so they told me that they don’t have entry level positions and senior positions are more than likely ending up on people who are already in the company. So basically I’m learning as much as I can during my spare time to then perhaps they let me stay after the internship extension ends by the end of the year.

  • @philhamlin7935

    @philhamlin7935

    2 жыл бұрын

    @@inspisiavideos8542 Congrats on your internship! Calling out 10 as a "magic number" is really great - bare numbers with no evident explanation can cause a lot of confusion in code, so 10 could be a constant called NUMBER_BASE since we're just using decimal notation here. For extra fun, make it not a constant, and adapt the algorithm to work in number bases other than 10!

  • @inspisiavideos8542

    @inspisiavideos8542

    2 жыл бұрын

    @@philhamlin7935 hey thanks! My internship was supposed to end in August but was extended to the end of December. I’ve been applying to other companies but nothing yet even though I have projects on my portfolio. My internship manager told me to stay alert when an opening occurs and apply. 2 positions opened and I applied there this week. Hopefully they’ll let me know and I be ready for a test code. The company has many teams so probably the person who sees my resume doesn’t know me yet.

  • @rotors_taker_0h
    @rotors_taker_0h Жыл бұрын

    For some reason it was extremely easy problem for me, first time that I just saw the solution instantly in full (unlike all “easy” ones before) and was so surprised of everyone’s animosity to this problem, lol.

  • @ahmetrauf2195
    @ahmetrauf21957 ай бұрын

    great explanation!

  • @jaisinha1378
    @jaisinha1378 Жыл бұрын

    Only Platform I choose for any coding explanation

  • @yuriish7570
    @yuriish7570 Жыл бұрын

    I cant figure out how does cur work. If I print id(cur) == id(dummy) it's true, but if i print cur and dummy inside or after while cycle the output is different. Tell me please what's going on or What should I google to clarify that ?

  • @Silver-lu1dt
    @Silver-lu1dt6 ай бұрын

    This is the way I learnt about pointer, I can't believe it

  • @rohanmahajan6333
    @rohanmahajan63335 ай бұрын

    so do we have a first node that is just null in all of these

  • @shantipriya370
    @shantipriya3702 ай бұрын

    wonderful explanation

  • @InfoBuzz1130
    @InfoBuzz1130 Жыл бұрын

    LOVE you my GURU your awesome!!!

  • @sangpark7656
    @sangpark7656 Жыл бұрын

    what's the function of next and val do?

  • @alyahmed9925
    @alyahmed9925 Жыл бұрын

    Can someone explain the dummy listnode and how changing in cur changes dummy?

  • @badachoi6882
    @badachoi6882 Жыл бұрын

    I did 'print(Solution().addTwoNumbers(l1,l2))' and got error "list object has no attribute 'val'... how do I fix it?

  • @vinaykumar-gg4mx
    @vinaykumar-gg4mx2 жыл бұрын

    A complete beginner question, how to call and declare the inputs for addTwoNumbers function, just to test the program !

  • @DracosThorne
    @DracosThorne11 ай бұрын

    NC: You do probably remember how to add two numbers together Me: You severely overestimate my abilities

  • @wlcheng
    @wlcheng2 жыл бұрын

    I am very happy for you that you are employed at Google now. 😀

  • @ABHINAVKUMAR-pl4iw
    @ABHINAVKUMAR-pl4iw2 жыл бұрын

    you are the legend

  • @NabeelGm
    @NabeelGm Жыл бұрын

    Can someone explain why we don't use the first dummy list node? Why not use dummy.val and assign?

  • @gimmeadollr

    @gimmeadollr

    Жыл бұрын

    I think it's because we want the logic to be "the next thing is ___" for every iteration, so we make a dummy list node and immediately start with our logic (the next thing for the dummy node is ___). If you use dummy.val, you have the first step do the logic of "the value here is ___" and then the later steps are "the next thing is ___" which is more inconvenient to write. That's how I thought of it, not sure if that's the right way to think about it.

  • @maharshibiswas3557
    @maharshibiswas355710 ай бұрын

    Inspirational first line

  • @noumaaaan
    @noumaaaan2 жыл бұрын

    A little confused,how are we adding in reverse order? we're just adding v1 and v2 which is normal addition isn't it?

  • @khatharrmalkavian3306

    @khatharrmalkavian3306

    2 жыл бұрын

    The digits are in reverse order.

  • @tomonkysinatree
    @tomonkysinatree29 күн бұрын

    I was really close to the solution on this one. I had an extra node at the end because I was creating my node in cur instead of cur.next(). Slowly getting better at these

  • @shooby117
    @shooby1177 ай бұрын

    "hey guys i am still unemployed so lets solve a problem" mans representing his entire audience 😂😂😂

  • @bizdep6237
    @bizdep62373 жыл бұрын

    @NeetCode Could you please explain the time complexity of the problems you solve? It will be really useful for us.

  • @wlockuz4467

    @wlockuz4467

    2 жыл бұрын

    For this one it should be O(n + m), where n is length of first linked list and m is length of second linked list.

  • @predatorgaming895

    @predatorgaming895

    2 жыл бұрын

    @@wlockuz4467 no bro... Either O(n) or O(n+1) where n is the length of linked list which has more nodes

  • @alok7485

    @alok7485

    2 жыл бұрын

    Can you please explain what will be the time complexity and space complexity for this piece of code in example?

  • @likkiii07

    @likkiii07

    Жыл бұрын

    @@alok7485 Time complexity will be O(max(n, m)) and Space complexity will be O(max(m,n))

  • @TheEllod
    @TheEllod2 жыл бұрын

    nulll and zero are different, you should instead append the while statement to while l1 or l2 or carry>0

  • @jaspreetsahota1840

    @jaspreetsahota1840

    7 ай бұрын

    In python, 0 evaluates to its Boolean value (False) in a conditional clause. So it's fine to just have carry.

  • @TheEllod

    @TheEllod

    7 ай бұрын

    @jaspreetsahota1840 good to know!

  • @oooo-rc2yf
    @oooo-rc2yf2 жыл бұрын

    If the person teaching these is unemployed what chances do we have...

  • @bulkan.evcimen
    @bulkan.evcimen8 ай бұрын

    this explanation is much better than the leetcode editorial

  • @tsunningwah3471

    @tsunningwah3471

    7 ай бұрын

    can anyone tell me why we're returning the dummy.next and not dummy itself? wont we be able to access every other element if we just return dummy?

  • @Moon-li9ki
    @Moon-li9ki2 ай бұрын

    I'm really proud of mylsef. I finally managed to solve a medium problem by myself, although my solution was slow as hell xd

  • @infos5319
    @infos53192 жыл бұрын

    Can you explain how can I call the l1 and l2 listnodes in the addtwonumber function to test?

  • @crosswalker45

    @crosswalker45

    2 жыл бұрын

    it's a bit compicated to explain it in words. I would rather suggest you to watch the videos on how to create linklist object and other related problems ( which aren't directly given into the function like this leetcode problem)

  • @mugilmithran6955

    @mugilmithran6955

    2 жыл бұрын

    @@crosswalker45 hi, thanks a lot man.

  • @stylisgames
    @stylisgames26 күн бұрын

    I was able to solve this one, but did not think of dividing the current sum by 10 and using Math.floor() to get the first digit as the carry number, and then using modulo to get the second number aka the current sum. So darn clever! Instead I converted the sum to a string and grabbed the values by index.

  • @sanooosai
    @sanooosai Жыл бұрын

    great thank you

  • @raviy10
    @raviy1010 ай бұрын

    Thank you !!!

  • @tsunningwah3471

    @tsunningwah3471

    7 ай бұрын

    can anyone tell me why we're returning the dummy.next and not dummy itself? wont we be able to access every other element if we just return dummy?

  • @dreamingaparisdream3178
    @dreamingaparisdream31783 жыл бұрын

    I got some errors when I ran your exact code. Is your solution missing the case when the highest position creates a carry of 1?

  • @yinglll7411

    @yinglll7411

    3 жыл бұрын

    you might have missed the "+ carry" bit when summing up the "val"

  • @dorb1337

    @dorb1337

    Жыл бұрын

    while l1 or l1 or carry:

  • @heyquantboy
    @heyquantboy3 жыл бұрын

    Beginner question- I wanted to build test cases before diving in. I went off on a tangent to construct ListNode instances- which I needed as inputs to LeetCode's provided addTwoNumbers interface. I prepared all my tests before even thinking about the solution. Is this wrong? I don't see anyone doing this. Is this wrong or shouldn't we do TDD?

  • @mrunfunny

    @mrunfunny

    2 жыл бұрын

    This is a perfectly valid strategy but it's time consuming and hence not popular in CP community.

  • @aumrudhlalkumartj1948
    @aumrudhlalkumartj1948 Жыл бұрын

    Thanks

  • @serpent2776
    @serpent27762 ай бұрын

    I am so happy that LC decided to give us reversed lists for this problem

  • @satyabharadwaj7779
    @satyabharadwaj7779 Жыл бұрын

    Can someone explain what happens inside the stack with the statements "cur = dummy" and "return dummy.next"?

  • @yipyiphooray339

    @yipyiphooray339

    Жыл бұрын

    curr is what you use to traverse the dummy linked list, while, "dummy" will always point at the head of the linked list. Since you're returning "dummy.next" you'll be returning the head of the resultant linked list.

  • @guyfieri4605
    @guyfieri4605 Жыл бұрын

    I don't understand what's going on with carry. Wouldn't always be a left over number there by the time two get to the second digit in the list nodes. First time through: val = 2 + 5 + 0 carry = 7 // 10 Doesn't that leave carry as .7 when we get to the next digits? I'm very confused.

  • @aiml66_bangerashashankchan81

    @aiml66_bangerashashankchan81

    Жыл бұрын

    In Python, we can perform floor division (also sometimes known as integer division) using the // operator. This operator will divide the first argument by the second and round the result down to the nearest whole number So, 7 // 10 = 0

  • @JC-yo5hu
    @JC-yo5hu9 ай бұрын

    When was dummy head ever updated in the code? Please help!

  • @computergeek5657
    @computergeek56572 жыл бұрын

    KZread hired u👍

  • @DanielSmith-uj7rr
    @DanielSmith-uj7rr2 жыл бұрын

    BRO! UNIQUE..!! "Hey Guys, I am still UNEMPLOYED so let's solve a problem!" Lmao!😂

  • @asmahamdym
    @asmahamdym Жыл бұрын

    Wow this is so clean✅✅ I brute- forced my way to this problem and it's functional but really ugly 😀

  • @ruslanruslan338
    @ruslanruslan338 Жыл бұрын

    Can anybody explain me? In the begin we wrote "dummy = cur". After that we updating "cur" in the while-loop. But we don't update "dummy". So how "dummy" is updating together with "cur" if we don't redefine "dummy = ..."

  • @joya9785

    @joya9785

    Жыл бұрын

    Exactly my doubt!!!

  • @sajithraj383
    @sajithraj3832 жыл бұрын

    Can Some please explain why the dummy is still getting updated when after the first iteration cur is updated to a different object. newNode = ListNode(columnSum % 10) curr.next = newNode curr = newNode

  • @robwalsh3858

    @robwalsh3858

    2 жыл бұрын

    At the start of the loop cur = dummy. On the first iteration you are assigning cur.next (aka dummy.next) with the first digit of the solution. So now dummy.next equals the head node of the solution so at the end we return dummy.next. dummy.next will always point to this head node no matter what cur gets changed to.

  • @ai4sme

    @ai4sme

    Жыл бұрын

    Hi Sajith, Here a good explanation: stackoverflow.com/questions/58759348/when-does-a-pointer-to-a-linked-list-change-the-actual-list

  • @drainedzombie2508

    @drainedzombie2508

    5 ай бұрын

    @@ai4sme Thanks for this. TIL python variables are essentially references/pointers to objects i.e. class instances.

  • @qazianeel
    @qazianeel2 жыл бұрын

    I have interview on 21st March, there is no way I am gonna pass :( This level of programming is going above my head

  • @supriyamanna715

    @supriyamanna715

    2 жыл бұрын

    kaya hua? Pass kiya tumne?

  • @alok7485

    @alok7485

    2 жыл бұрын

    Did u pass?

  • @Davidsito44

    @Davidsito44

    11 ай бұрын

    how did it goes?

  • @sukanyabag6134
    @sukanyabag61343 жыл бұрын

    Hey, it is showing the time limit exceeded! Please help!

  • @sumanth5087

    @sumanth5087

    3 жыл бұрын

    see in discus section there u can see many solutions

  • @roy761017
    @roy761017 Жыл бұрын

    Hi. Can someone help me understand how and why there is l1.val? I thought l1 is a list which is [2, 4, 3]? How does l1.val calling integer 2? Or it's from ListNode class? I'm very confused.

  • @smilenpassion

    @smilenpassion

    Жыл бұрын

    if you see the ListNode class there is a val, which is used to access the int values of the nodes so it is used as node.val (in this case l1.val) hope it helps

  • @roy761017

    @roy761017

    Жыл бұрын

    Hi @@smilenpassion thank you for your respond, but I am still confused. Class listnode is not inheritance under class solution. How can class solution call any object from class listnode? Also, even it can call the object from listnode, shouldn't be v1 = self.val if l1? Or set the self.val to l1.val? Thank you again for helping me to understand it

  • @EranM
    @EranM2 ай бұрын

    "Hey guys, I'm still unemployed.." Many kisses for you neet! you make me laugh.. And relax... To the best ASMR Channel OUT-THERE!!!! Please go back to this microphone and keyboard, and relaxed voice!!!!!!!!! damn I enjoy this

  • @tirasjeffrey2002
    @tirasjeffrey20028 ай бұрын

    can anyone tell me why we're returning the dummy.next and not dummy itself? wont we be able to access every other element if we just return dummy?

  • @tsunningwah3471

    @tsunningwah3471

    7 ай бұрын

    yes i have the same question too. I thought dummy itself is the real list

  • @m0sh3

    @m0sh3

    7 ай бұрын

    @@tsunningwah3471 dummy is initialized to default value of 0 for the purpose of having an initial node to attach everything else to. dummy.next is the real start of the summed list.

  • @tsunningwah3471

    @tsunningwah3471

    7 ай бұрын

    @@m0sh3 thanks got it!

  • @iambdot
    @iambdot Жыл бұрын

    Stupid question but how does "dummy" get updated when all code changes are done to "cur"?

  • @chillcoder

    @chillcoder

    Жыл бұрын

    Both dummy and cur are both pointers to the same list, but serve different purposes: We are using dummy to point to the start of the list and cur will be used to add additional nodes + move to the latest node in the list.

  • @adityadixit1404
    @adityadixit1404 Жыл бұрын

    To deal with edge case just before . return dummy.next write If carry==1: cur.next= ListNode (1)

  • @indhumathi5846
    @indhumathi5846 Жыл бұрын

    understood

  • @lilyh4573
    @lilyh45732 жыл бұрын

    This was hard argh I had no idea how to implement carry. Thank you for explaining! I don't understand the dummy node part. can we not use a dummy node? Why not use curr and return curr?

  • @austinpatton3771

    @austinpatton3771

    Жыл бұрын

    You could, but in my experience the dummy node generally makes building the linked list easier since you can loop through it with less conditional statements. If you don't make the dummy node, you would either have to have a separate if statement to check that our starting node is not null or find some other way to do a one-off initialization of the list. With the dummy node, you can process the nodes each time without having to worry about if it's your starting node or not.

  • @ahmxrd
    @ahmxrd3 жыл бұрын

    Why are these things so difficult 😣?

  • @theunderhook9913
    @theunderhook99132 жыл бұрын

    Why can;t we simply reverse two lists first, sum them and then reverse an output?

  • @dr.merlot1532
    @dr.merlot15322 жыл бұрын

    My sentiments exactly. If NeetCode is unemployed, what chances do we have...

  • @NeetCode

    @NeetCode

    2 жыл бұрын

    Well.. not anymore :p

  • @dr.merlot1532

    @dr.merlot1532

    2 жыл бұрын

    @@NeetCode In my heart and mind, you are still unemployed.

  • @alicia8170
    @alicia8170 Жыл бұрын

    At the start of the loop cur = dummy. On the first iteration you are assigning cur.next (aka dummy.next) with the first digit of the solution. So now dummy.next equals the head node of the solution so at the end we return dummy.next. dummy.next will always point to this head node no matter what cur gets changed to.

  • @alicia8170

    @alicia8170

    Жыл бұрын

    I quote your response to ask the question further. As I understand, cur = dummy means let cur be dummy, but they are not the same one. I still don't understand whey cur.next will change dummy.next. Did I miss anything? Thank you so much!

  • @oliverbao4925

    @oliverbao4925

    6 ай бұрын

    @@alicia8170 hi yeah i'm wondering the same thing - although we didn't reference dummy at all or change its value, it gets built on as we change cur and cur.next - is this a python binding or pointer issue?

  • @symbol767
    @symbol7672 жыл бұрын

    0:00 Lol now you're at Google. Here I am just trying to get Amazon or Microsoft now. Awesome solution, I managed to actually solve this one myself but wanted to see your way of doing it, much cleaner. Thank you! Liked!

  • @giggity30
    @giggity302 жыл бұрын

    "I am still unemployed" Not anymore!

  • @techenthusiast3966
    @techenthusiast39662 жыл бұрын

    Here after when you got job in Google.... congratulations:)

  • @mdshakilzaman1845
    @mdshakilzaman1845 Жыл бұрын

    how dummy variable is updated through while loop?

  • @shivakhatri3271

    @shivakhatri3271

    Жыл бұрын

    did you figure it out?

  • @-Mohamed_bayan

    @-Mohamed_bayan

    11 ай бұрын

    Learn how linkedlist words

  • @Tulshirampradip
    @Tulshirampradip Жыл бұрын

    How to achieve time complexity o(n)?

  • @likkiii07

    @likkiii07

    Жыл бұрын

    You can't. It's always going to be the length of the larger list. Hence O(max(m,n))

  • @m0sh3
    @m0sh37 ай бұрын

    This code only passes 1365/1568 test cases. Update needed.

  • @aryanbisht8733
    @aryanbisht8733 Жыл бұрын

    this solution gives TLE (Time Limit Exceeded) any other solution?

  • @NeetCode

    @NeetCode

    Жыл бұрын

    Most likely you have an infinite loop somewhere, are you updating your pointers?

  • @shivamlokhande4856
    @shivamlokhande48562 жыл бұрын

    gold

  • @ABagOfLag
    @ABagOfLag4 ай бұрын

    i solved it using more memory but it eliminates thinking about edge cases: nums1, nums2 = [], [] cur = l1 while cur: nums1.append(cur.val) cur = cur.next cur = l2 while cur: nums2.append(cur.val) cur = cur.next nums1 = nums1[::-1] nums2 = nums2[::-1] num1 = int(''.join(map(str, nums1))) num2 = int(''.join(map(str, nums2))) vals = [] number = str(num1 + num2) for c in number: vals.append(int(c)) dummy = ListNode(0) cur = dummy while vals: cur.next = ListNode(vals.pop()) cur = cur.next return dummy.next

  • @lifeofme3172
    @lifeofme31729 ай бұрын

    could have reduced these statements within single block, otherwise awesome explanation thank you if(l1 != null){ v1 = l1.val; l1 = l1.next; } if(l2 != null){ v2 = l2.val; l2 = l2.next; }

  • @minecraftredstoneinspiration
    @minecraftredstoneinspiration Жыл бұрын

    Why can't you reverse both list and just add the two reversed list together?

  • @neelshah1617
    @neelshah1617 Жыл бұрын

    Thank you for a quick solution! However, it is not space optimized as per the requirement: Ignoring the allocation of a new linked list, try to use constant memory when solving it. Would be better to add summation digits in longer LL.

Келесі